/// <reference types="stripe/types/crypto/crypto" />
/// <reference types="stripe/types/shared" />
/// <reference types="stripe/types/errors" />
/// <reference types="stripe/types/oauth" />
/// <reference types="stripe/types/webhooks" />
/// <reference types="stripe/types/upcominginvoices" />
/// <reference types="stripe/types/accountlinksresource" />
/// <reference types="stripe/types/accountsresource" />
/// <reference types="stripe/types/applepaydomainsresource" />
/// <reference types="stripe/types/applicationfeesresource" />
/// <reference types="stripe/types/apps/secretsresource" />
/// <reference types="stripe/types/balanceresource" />
/// <reference types="stripe/types/balancetransactionsresource" />
/// <reference types="stripe/types/billingportal/configurationsresource" />
/// <reference types="stripe/types/billingportal/sessionsresource" />
/// <reference types="stripe/types/chargesresource" />
/// <reference types="stripe/types/checkout/sessionsresource" />
/// <reference types="stripe/types/countryspecsresource" />
/// <reference types="stripe/types/couponsresource" />
/// <reference types="stripe/types/creditnotesresource" />
/// <reference types="stripe/types/customersresource" />
/// <reference types="stripe/types/disputesresource" />
/// <reference types="stripe/types/ephemeralkeysresource" />
/// <reference types="stripe/types/eventsresource" />
/// <reference types="stripe/types/exchangeratesresource" />
/// <reference types="stripe/types/filelinksresource" />
/// <reference types="stripe/types/filesresource" />
/// <reference types="stripe/types/financialconnections/accountsresource" />
/// <reference types="stripe/types/financialconnections/sessionsresource" />
/// <reference types="stripe/types/identity/verificationreportsresource" />
/// <reference types="stripe/types/identity/verificationsessionsresource" />
/// <reference types="stripe/types/invoiceitemsresource" />
/// <reference types="stripe/types/invoicesresource" />
/// <reference types="stripe/types/issuing/authorizationsresource" />
/// <reference types="stripe/types/issuing/cardholdersresource" />
/// <reference types="stripe/types/issuing/cardsresource" />
/// <reference types="stripe/types/issuing/disputesresource" />
/// <reference types="stripe/types/issuing/transactionsresource" />
/// <reference types="stripe/types/mandatesresource" />
/// <reference types="stripe/types/paymentintentsresource" />
/// <reference types="stripe/types/paymentlinksresource" />
/// <reference types="stripe/types/paymentmethodsresource" />
/// <reference types="stripe/types/payoutsresource" />
/// <reference types="stripe/types/plansresource" />
/// <reference types="stripe/types/pricesresource" />
/// <reference types="stripe/types/productsresource" />
/// <reference types="stripe/types/promotioncodesresource" />
/// <reference types="stripe/types/quotesresource" />
/// <reference types="stripe/types/radar/earlyfraudwarningsresource" />
/// <reference types="stripe/types/radar/valuelistitemsresource" />
/// <reference types="stripe/types/radar/valuelistsresource" />
/// <reference types="stripe/types/refundsresource" />
/// <reference types="stripe/types/reporting/reportrunsresource" />
/// <reference types="stripe/types/reporting/reporttypesresource" />
/// <reference types="stripe/types/reviewsresource" />
/// <reference types="stripe/types/setupattemptsresource" />
/// <reference types="stripe/types/setupintentsresource" />
/// <reference types="stripe/types/shippingratesresource" />
/// <reference types="stripe/types/sigma/scheduledqueryrunsresource" />
/// <reference types="stripe/types/sourcesresource" />
/// <reference types="stripe/types/subscriptionitemsresource" />
/// <reference types="stripe/types/subscriptionschedulesresource" />
/// <reference types="stripe/types/subscriptionsresource" />
/// <reference types="stripe/types/tax/calculationsresource" />
/// <reference types="stripe/types/tax/transactionsresource" />
/// <reference types="stripe/types/taxcodesresource" />
/// <reference types="stripe/types/taxratesresource" />
/// <reference types="stripe/types/terminal/configurationsresource" />
/// <reference types="stripe/types/terminal/connectiontokensresource" />
/// <reference types="stripe/types/terminal/locationsresource" />
/// <reference types="stripe/types/terminal/readersresource" />
/// <reference types="stripe/types/testhelpers/customersresource" />
/// <reference types="stripe/types/testhelpers/issuing/cardsresource" />
/// <reference types="stripe/types/testhelpers/refundsresource" />
/// <reference types="stripe/types/testhelpers/terminal/readersresource" />
/// <reference types="stripe/types/testhelpers/testclocksresource" />
/// <reference types="stripe/types/testhelpers/treasury/inboundtransfersresource" />
/// <reference types="stripe/types/testhelpers/treasury/outboundpaymentsresource" />
/// <reference types="stripe/types/testhelpers/treasury/outboundtransfersresource" />
/// <reference types="stripe/types/testhelpers/treasury/receivedcreditsresource" />
/// <reference types="stripe/types/testhelpers/treasury/receiveddebitsresource" />
/// <reference types="stripe/types/tokensresource" />
/// <reference types="stripe/types/topupsresource" />
/// <reference types="stripe/types/transfersresource" />
/// <reference types="stripe/types/treasury/creditreversalsresource" />
/// <reference types="stripe/types/treasury/debitreversalsresource" />
/// <reference types="stripe/types/treasury/financialaccountsresource" />
/// <reference types="stripe/types/treasury/inboundtransfersresource" />
/// <reference types="stripe/types/treasury/outboundpaymentsresource" />
/// <reference types="stripe/types/treasury/outboundtransfersresource" />
/// <reference types="stripe/types/treasury/receivedcreditsresource" />
/// <reference types="stripe/types/treasury/receiveddebitsresource" />
/// <reference types="stripe/types/treasury/transactionentriesresource" />
/// <reference types="stripe/types/treasury/transactionsresource" />
/// <reference types="stripe/types/webhookendpointsresource" />
/// <reference types="stripe/types/accountlinks" />
/// <reference types="stripe/types/accounts" />
/// <reference types="stripe/types/applepaydomains" />
/// <reference types="stripe/types/applicationfees" />
/// <reference types="stripe/types/applications" />
/// <reference types="stripe/types/apps/secrets" />
/// <reference types="stripe/types/balance" />
/// <reference types="stripe/types/balancetransactions" />
/// <reference types="stripe/types/bankaccounts" />
/// <reference types="stripe/types/billingportal/configurations" />
/// <reference types="stripe/types/billingportal/sessions" />
/// <reference types="stripe/types/capabilities" />
/// <reference types="stripe/types/cards" />
/// <reference types="stripe/types/cashbalances" />
/// <reference types="stripe/types/charges" />
/// <reference types="stripe/types/checkout/sessions" />
/// <reference types="stripe/types/connectcollectiontransfers" />
/// <reference types="stripe/types/countryspecs" />
/// <reference types="stripe/types/coupons" />
/// <reference types="stripe/types/creditnotelineitems" />
/// <reference types="stripe/types/creditnotes" />
/// <reference types="stripe/types/customerbalancetransactions" />
/// <reference types="stripe/types/customercashbalancetransactions" />
/// <reference types="stripe/types/customers" />
/// <reference types="stripe/types/discounts" />
/// <reference types="stripe/types/disputes" />
/// <reference types="stripe/types/ephemeralkeys" />
/// <reference types="stripe/types/events" />
/// <reference types="stripe/types/exchangerates" />
/// <reference types="stripe/types/feerefunds" />
/// <reference types="stripe/types/filelinks" />
/// <reference types="stripe/types/files" />
/// <reference types="stripe/types/financialconnections/accountowners" />
/// <reference types="stripe/types/financialconnections/accountownerships" />
/// <reference types="stripe/types/financialconnections/accounts" />
/// <reference types="stripe/types/financialconnections/sessions" />
/// <reference types="stripe/types/fundinginstructions" />
/// <reference types="stripe/types/identity/verificationreports" />
/// <reference types="stripe/types/identity/verificationsessions" />
/// <reference types="stripe/types/invoiceitems" />
/// <reference types="stripe/types/invoicelineitems" />
/// <reference types="stripe/types/invoices" />
/// <reference types="stripe/types/issuing/authorizations" />
/// <reference types="stripe/types/issuing/cardholders" />
/// <reference types="stripe/types/issuing/cards" />
/// <reference types="stripe/types/issuing/disputes" />
/// <reference types="stripe/types/issuing/transactions" />
/// <reference types="stripe/types/lineitems" />
/// <reference types="stripe/types/loginlinks" />
/// <reference types="stripe/types/mandates" />
/// <reference types="stripe/types/paymentintents" />
/// <reference types="stripe/types/paymentlinks" />
/// <reference types="stripe/types/paymentmethods" />
/// <reference types="stripe/types/payouts" />
/// <reference types="stripe/types/persons" />
/// <reference types="stripe/types/plans" />
/// <reference types="stripe/types/platformtaxfees" />
/// <reference types="stripe/types/prices" />
/// <reference types="stripe/types/products" />
/// <reference types="stripe/types/promotioncodes" />
/// <reference types="stripe/types/quotes" />
/// <reference types="stripe/types/radar/earlyfraudwarnings" />
/// <reference types="stripe/types/radar/valuelistitems" />
/// <reference types="stripe/types/radar/valuelists" />
/// <reference types="stripe/types/refunds" />
/// <reference types="stripe/types/reporting/reportruns" />
/// <reference types="stripe/types/reporting/reporttypes" />
/// <reference types="stripe/types/reservetransactions" />
/// <reference types="stripe/types/reviews" />
/// <reference types="stripe/types/setupattempts" />
/// <reference types="stripe/types/setupintents" />
/// <reference types="stripe/types/shippingrates" />
/// <reference types="stripe/types/sigma/scheduledqueryruns" />
/// <reference types="stripe/types/sourcemandatenotifications" />
/// <reference types="stripe/types/sourcetransactions" />
/// <reference types="stripe/types/sources" />
/// <reference types="stripe/types/subscriptionitems" />
/// <reference types="stripe/types/subscriptionschedules" />
/// <reference types="stripe/types/subscriptions" />
/// <reference types="stripe/types/tax/calculationlineitems" />
/// <reference types="stripe/types/tax/calculations" />
/// <reference types="stripe/types/tax/transactionlineitems" />
/// <reference types="stripe/types/tax/transactions" />
/// <reference types="stripe/types/taxcodes" />
/// <reference types="stripe/types/taxdeductedatsources" />
/// <reference types="stripe/types/taxids" />
/// <reference types="stripe/types/taxrates" />
/// <reference types="stripe/types/terminal/configurations" />
/// <reference types="stripe/types/terminal/connectiontokens" />
/// <reference types="stripe/types/terminal/locations" />
/// <reference types="stripe/types/terminal/readers" />
/// <reference types="stripe/types/testhelpers/testclocks" />
/// <reference types="stripe/types/tokens" />
/// <reference types="stripe/types/topups" />
/// <reference types="stripe/types/transferreversals" />
/// <reference types="stripe/types/transfers" />
/// <reference types="stripe/types/treasury/creditreversals" />
/// <reference types="stripe/types/treasury/debitreversals" />
/// <reference types="stripe/types/treasury/financialaccountfeatures" />
/// <reference types="stripe/types/treasury/financialaccounts" />
/// <reference types="stripe/types/treasury/inboundtransfers" />
/// <reference types="stripe/types/treasury/outboundpayments" />
/// <reference types="stripe/types/treasury/outboundtransfers" />
/// <reference types="stripe/types/treasury/receivedcredits" />
/// <reference types="stripe/types/treasury/receiveddebits" />
/// <reference types="stripe/types/treasury/transactionentries" />
/// <reference types="stripe/types/treasury/transactions" />
/// <reference types="stripe/types/usagerecordsummaries" />
/// <reference types="stripe/types/usagerecords" />
/// <reference types="stripe/types/webhookendpoints" />
/// <reference types="stripe/types/lib" />
/// <reference types="stripe/types/net/net" />
import * as React from "react";
import Stripe from "stripe";
export interface State {
    loaded: boolean;
    liveMode: boolean;
    signInModalVisible: boolean;
    stripeAccount?: string;
    user: any;
    authStateListener: () => void;
    authStateLoading: boolean;
    authError: string | null;
    stripe: Stripe | null;
    activeSubscriptions?: Stripe.Subscription[];
    subscriptions?: Stripe.Subscription[];
    product?: Product;
    pricing?: SelectedPricing;
    promotionCode?: Stripe.PromotionCode;
    modalOptions: ModalOptions;
    billingOptions: BillingOptions;
    paymentModalVisible: boolean;
    paymentError: string;
    defaultCustomerName: string;
    operationSuccessful: "payment" | "update" | null;
    isPaymentProcessing: boolean;
    paymentRequest: any;
    onPaymentSuccessful: () => void;
    onPaymentError: (error: Error) => void;
    onError: (error: BillingError) => void;
    getEmailHmac: (() => {
        email: string;
        hmac?: string;
    } | Promise<{
        email: string;
        hmac?: string;
    }>) | null;
    onCustomerSignedOut: () => void;
    onCustomerSignedIn: () => void;
}
export interface User {
    email: string;
    stripeAccount: string | undefined;
    stripeCustomer: string | undefined;
}
export interface SharedSubscriptionUser {
    stripeCustomer: string | null | undefined;
    createdAt: number;
    email: string | null;
    name?: string | null;
    action?: string | null;
    role: "owner" | "manager" | "user";
    sharedSubscriptionId: string | null;
}
export declare enum BillingMetadata {
    "billing_match_country_currency" = "billing_match_country_currency",
    "billing_shared_subscription_id" = "billing_shared_subscription_id",
    "billing_shared_subscription_role" = "billing_shared_subscription_role",
    "billing_shared_subscription_owner" = "billing_shared_subscription_owner",
    "billing_supports_shared_subscriptions" = "billing_supports_shared_subscriptions",
    "billing_full_refund_max_days" = "billing_full_refund_max_days"
}
export type RecurrenceTypes = "yearly" | "biyearly" | "quarterly" | "monthly" | "weekly" | "daily";
export type IntervalType = "day" | "week" | "month" | "year";
export type NormalizedIntervalType = "yearly" | "quarterly" | "monthly" | "daily";
export interface Price extends Stripe.Price {
    product: Stripe.Product;
}
export interface SubscriptionItem extends Stripe.SubscriptionItem {
    price: Price;
}
export type UpcomingInvoice = Stripe.UpcomingInvoice;
export interface LatestInvoice extends Stripe.Invoice {
    payment_intent: Stripe.PaymentIntent;
}
export interface Subscription extends Stripe.Subscription {
    customer: Stripe.Customer;
    plan: Stripe.Plan;
    items: Stripe.ApiList<SubscriptionItem>;
    latest_invoice: LatestInvoice;
}
export interface ModalOptions {
    maskClassName?: string;
    showPromotionCodeInput?: boolean;
    showPricingSummary?: boolean;
    showOneClickPaymentButton?: boolean;
}
export declare enum BillingErrorType {
    "unauthorized" = "unauthorized",
    "customer_not_found" = "customer_not_found",
    "stripe_account_not_found" = "stripe_account_not_found",
    "internal" = "internal"
}
export interface BillingError {
    type: BillingErrorType;
    error: Error;
}
export interface BillingOptions {
    productPageUrl?: string;
    customerPortalUrl?: string;
    termsAndConditionsUrl?: string;
    privacyPolicyUrl?: string;
    showTermsAndConditions?: boolean;
    showPrivacyPolicy?: boolean;
    cancelSubscriptionOptions?: {
        showModal?: boolean;
        cancelMessage?: string;
    };
}
export interface UseProductsOptions {
    defaultCurrency?: string;
    defaultCustomerName?: string;
    defaultRecurrence?: RecurrenceTypes;
    modal?: ModalOptions;
    normalizePriceOnRecurrence?: NormalizedIntervalType;
    onSignIn?: () => void;
    onPaymentSuccessful?: () => void;
    onPaymentError?: () => void;
}
export interface SelectedPricing extends Stripe.Price {
    currencyObject: Currency;
    onSelectPricing: () => void;
    PaymentButton: (props?: any) => JSX.Element;
    quantity: number;
    priceInteger: number | React.ReactNode;
    priceDecimal: number | React.ReactNode;
    priceFormatted: string | React.ReactNode;
    price: string | React.ReactNode;
    pricingRecurrence: string | React.ReactNode;
    billingRecurrence: string | React.ReactNode;
    billedPrice: string | React.ReactNode;
    hasTrial: boolean;
}
export interface Currency {
    id: string;
    symbol: string | React.ReactNode;
    name: string | React.ReactNode;
    decimal_digits: number;
    code: string | React.ReactNode;
}
export interface PricingFilter {
    currency: {
        selectedCurrency: Currency;
        availableCurrencies: Currency[];
        setCurrency: (Currency: any) => void;
    };
    recurrence: {
        selectedRecurrence: Recurrence;
        availableRecurrences: Recurrence[];
        setRecurrence: (Recurrence: any) => void;
    };
}
export interface Product extends Stripe.Product {
    pricings: Price[];
    selectedPricing: SelectedPricing;
}
export interface Recurrence {
    name: string | React.ReactNode;
    interval: string | React.ReactNode;
    interval_count: number;
}
export interface Invoice extends Stripe.Invoice {
    payment_intent: PaymentIntent;
    charge: Stripe.Charge;
}
export type PaymentIntent = Stripe.PaymentIntent;
export interface PaymentMethod extends Stripe.PaymentMethod {
    customer: Stripe.Customer;
}
export interface Coupon {
    id: string;
    object: string;
    amount_off: number;
    created: number;
    currency: string;
    duration: string;
    duration_in_months: any;
    livemode: boolean;
    max_redemptions: any;
    metadata: any;
    name: string;
    percent_off: any;
    redeem_by: any;
    times_redeemed: number;
    valid: boolean;
}
export interface Customer {
    id: string;
    address?: string | React.ReactNode;
    balance?: number;
    created?: number;
    currency?: string | React.ReactNode;
    default_source?: string | React.ReactNode;
    description?: string | React.ReactNode;
    discount?: string | React.ReactNode;
    email?: string | React.ReactNode;
    livemode?: boolean;
    metadata?: any;
    name?: string | React.ReactNode;
    phone?: string | React.ReactNode;
    shipping?: string | React.ReactNode;
    paymentMethods?: PaymentMethod[];
    subscriptions?: Subscription[];
    invoices?: Invoice[];
}
export interface Pricing {
    id: string;
    active: boolean;
    currency: string | Currency;
    billing_scheme?: string;
    livemode?: boolean;
    lookup_key?: string;
    metadata?: any;
    nickname?: string;
    product?: string;
    recurring: {
        aggregate_usage: string;
        interval: string | React.ReactNode;
        interval_count: number;
        trial_period_days: number;
        usage_type: string;
    };
    tiers_mode?: string;
    transform_quantity?: string;
    type?: string;
    unit_amount: number;
    unit_amount_decimal: number;
}
export interface TaxID {
    id: string;
    name: string;
    country: string;
    icon: () => JSX.Element;
    format: string;
    placeholder: string;
}
